<template>
  <div class="permissions wp-layout">
    <div class="wp-field wp-field--notify wp-12"
      v-if="$props.permissions.length === 0">
      Разрешения не заданы
    </div>
    <div class="spoiler wp-12" v-for="permissionType in displayPermissions"
      :key="permissionType.type" :class="{ 'spoiler--opened': permissionType.is_opened }">
      <div class="spoiler-title wp-12" @click="changeOpenState(permissionType.type)">
        <div class="spoiler-title__text">
          {{ permissionType.name }}
        </div>
        <div class="spoiler-title__info">
          <div class="wp-indicators wp-indicators--title" v-if="permissionType.is_opened">
            <div class="wp-indicator">S</div>
            <div class="wp-indicator">C</div>
            <div class="wp-indicator">R</div>
            <div class="wp-indicator">U</div>
            <div class="wp-indicator">D</div>
          </div>
          <div class="spoiler-title__action">
            <font-awesome-icon icon="angle-down" size="sm" class="spoiler-title__icon"/>
          </div>
        </div>
      </div>
      <div class="spoiler-content">
        <div class="spoiler-content__row"
          v-for="(permission, index) in permissionType.permissions" :key="index">
          <div class="row-text">
            {{ permission._display_name }}
          </div>
          <div class="wp-indicators">
            <div class="wp-indicator"
              :class="{
                'wp-indicator--primary': permission.self,
                'wp-indicator--secondary': !permission.self,
              }"></div>
            <div class="wp-indicator"
              :class="{
                'wp-indicator--primary': permission.create,
                'wp-indicator--secondary': !permission.create,
              }"></div>
            <div class="wp-indicator"
              :class="{
                'wp-indicator--primary': permission.read,
                'wp-indicator--secondary': !permission.read,
              }"></div>
            <div class="wp-indicator"
              :class="{
                'wp-indicator--primary': permission.update,
                'wp-indicator--secondary': !permission.update,
              }"></div>
            <div class="wp-indicator"
              :class="{
                'wp-indicator--primary': permission.delete,
                'wp-indicator--secondary': !permission.delete,
              }"></div>
          </div>
          <div class="row-action" @click="$emit('edit', permission)">
            <font-awesome-icon icon="pen" size="xs" class="row-action__icon"/>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex';

import {
  PermissionsTypes,
  PermissionsTypesNames,
} from '@/shared';

export default {
  name: 'PermissionsTable',
  props: {
    permissions: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      PermissionsTypes,
      PermissionsTypesNames,
      displayPermissions: Object.keys(PermissionsTypesNames).reduce((
        result,
        permissionType,
      ) => {
        const newObect = {};
        newObect[permissionType] = {};
        return Object.assign(result, newObect);
      }, {}),
    };
  },
  computed: {
    ...mapState('organization', ['organization']),
    ...mapGetters('organization', [
      'memberByID',
      'categoryByID',
      'roleByID',
      'reasonByID',
      'groupByID',
    ]),
  },
  methods: {
    getPermissionByID(permissionID) {
      return this.$props.permissions.find(item => item.id === permissionID);
    },
    changeOpenState(permissionType) {
      this.displayPermissions[permissionType].is_opened = !this.displayPermissions[
        permissionType
      ].is_opened;
    },
    getResourceName(permissionType, resourceID) {
      if (resourceID === null) return 'Общее разрешение';
      switch (Number(permissionType)) {
        case PermissionsTypes.Organization: {
          return this.organization.name;
        }
        case PermissionsTypes.Members: {
          return this.memberByID[resourceID];
        }
        case PermissionsTypes.Roles: {
          return this.roleByID[resourceID];
        }
        case PermissionsTypes.Reasons: {
          return this.reasonByID[resourceID];
        }
        case PermissionsTypes.Categories: {
          return this.categoryByID[resourceID];
        }
        case PermissionsTypes.Groups: {
          return this.groupByID[resourceID];
        }
        case PermissionsTypes.Grades: {
          return this.categoryByID[resourceID];
        }
        default: {
          return 'Ошибка';
        }
      }
    },
    updateDisplayPermissions() {
      const result = {};
      this.$props.permissions.forEach((permission) => {
        if (!result[permission.type]) {
          result[permission.type] = {
            is_opened: this.displayPermissions[permission.type]
              ? this.displayPermissions[permission.type].is_opened : false,
            name: PermissionsTypesNames[permission.type],
            type: permission.type,
            permissions: [],
          };
        }
        result[permission.type].permissions.push({
          ...permission,
          _display_name: this.getResourceName(permission.type, permission.resource),
        });
      });
      this.displayPermissions = result;
    },
  },
  created() {
    this.updateDisplayPermissions();
  },
  watch: {
    permissions() {
      this.updateDisplayPermissions();
    },
  },
};
</script>

<style lang="scss" scoped>
.permissions {

  .spoiler {
    margin-bottom: 10px;

    &:last-child {
      margin-bottom: 15px;
    }

    &--opened {

      .spoiler-title {

        &__icon {
          transform: rotateZ(180deg);
        }

      }

      .spoiler-content {
        max-height: unset;
      }

    }

    &-title {
      display: flex;
      align-items: center;
      margin-bottom: 5px;

      &:hover {
        cursor: pointer;
      }

      &__text {
        flex: 1;
        color: $neutralDarker;
        font-family: $firaSans;
        font-size: 15px;
      }

      &__info {
        justify-self: end;
        margin-left: auto;
        display: flex;
        justify-content: flex-end;
        align-items: center;

        > .wp-indicators {
          margin-right: 10px;
        }

      }

      &__action {
        height: 15px;
        width: 15px;
        display: flex;
        justify-content: center;
        align-items: center;
      }

      &__icon {
        margin-top: 1px;
        color: $neutralDarker;
        transition: transform ease-in-out .2s;
      }

    }

    &-content {
      max-height: 0;
      overflow-y: hidden;

      &__row {
        display: flex;
        align-items: center;
        margin-bottom: 5px;

        > .wp-indicators {
          margin-right: 10px;
        }

        .row {

          &-text {
            font-size: 15px;
            font-family: $roboto;
          }

          &-action {
            height: 15px;
            width: 15px;
            display: flex;
            justify-content: center;
            align-items: center;

            &__icon {
              color: $neutralDark;
              transition: color ease-in-out .2s;
            }

            &:hover {
              cursor: pointer;

              .row-action__icon {
                color: $primary;
              }

            }

          }

        }

      }

    }

  }

}
</style>
